import BuildLP

def KnockOutImpacts(m,lp=None, tol=1e-4):

    rv = {}
    tol += 1.0

    if lp == None:
        lp = BuildLP.BuildLP(m)

    lp.Solve()
    WTVal = lp.GetObjVal()         # the "wild-type fitness"

    for reac in m.sm.cnames:       # for all reactions in the model

        if not  "_tx" in reac:     # if it's not a  transporter
            lp.SetFixedFlux({reac:0}) # remove it - ie set flux to zero
            lp.Solve(False)           # try and get a solution, False - don't print status
            print ".",                # show progress
            if lp.GetStatusMsg() == 'Optimal':    # got a solution
                impact = lp.GetObjVal()/WTVal     # calculate the impact
                if impact > tol:                  # if it's worth reporting
                    rv[reac] = lp.GetObjVal()/WTVal   # record impact on objective
            else:
                rv[reac] = "Not viable"           # no solution for this KO

            lp.ClearFluxConstraint(reac) # remove the flux bound on reac

    return rv  # return the results
